﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Sunweb.BusinessLayer;
using Sunweb.DataAccessLayer;
using Infragistics.Web.UI.GridControls;
using Infragistics.Web.UI.NavigationControls;
using Infragistics.Web.UI.LayoutControls;
using AzMan;

namespace GoGoYield
{
    public partial class Prices : System.Web.UI.Page
    {
        #region Private members
        private enum Tabs { Selection, Prices };
        private enum Actions { Selection, Prices, SetOverrules, SentToDavinci };
        private ProductSelection clsProductSelection;
        private PriceSelection clsPriceSelection;
        //private ArrayList Filter;
        //private DataLayer.Prices.PricesDataTable prices;
        #endregion

        protected void Page_Load(object sender, EventArgs e)
        {
            CheckAccess azMan;
            azMan = new CheckAccess();

            // check if user has access to the prices tab
            if (!azMan.HasAccessToPage(Resources.PricesTab.ToString()))
                Response.Write("GEEN TOEGANG");

            if (!IsPostBack)
            {
                clsPriceSelection = new PriceSelection();
                clsProductSelection = new ProductSelection();

                SetBrandTree();
                SetRegionTree();
                SetPricesGrid();

                ShowSelectionTab();

                Session["ProductSelection"] = clsProductSelection;
                Session["PriceSelection"] = clsPriceSelection;

            }
            else
            {
                clsPriceSelection = (PriceSelection)Session["PriceSelection"];
                clsProductSelection = (ProductSelection)Session["ProductSelection"];
            }
        }

        protected void ShowSelectionTab()
        {
            UpdateActionsMenu(Actions.Selection);

            pnlPricesGridActions.Visible = false;

            wtPrices.SelectedIndex = (int)Tabs.Selection;
        }

        protected void ShowPricesTab()
        {
            SetPricesGridData(GetPriceFilter());
            
            UpdateActionsMenu(Actions.Prices);

            pnlPricesGridActions.Visible = true;

            wtPrices.SelectedIndex = (int)Tabs.Prices;
        }


        protected void wdmPricesActions_ItemClick(object sender, Infragistics.Web.UI.NavigationControls.DataMenuItemEventArgs e)
        {
                           
            if (e.Item != null)
            {
               if (e.Item.Text == wdmPricesActions.Items[(int)Actions.Selection].Text)
                {
                    ShowSelectionTab();
                   
                }
                else if (e.Item.Text == wdmPricesActions.Items[(int)Actions.Prices].Text)
                {
                    ShowPricesTab();
                }
                
            }
        }

        private void UpdateActionsMenu(Actions currentAction)
        {
            switch(currentAction)
            {
                case Actions.Selection:
                     wdmPricesActions.Items[(int)Actions.Selection].Enabled = false;
                     wdmPricesActions.Items[(int)Actions.Prices].Enabled = true;
                     wdmPricesActions.Items[(int)Actions.SetOverrules].Enabled = false;
                     wdmPricesActions.Items[(int)Actions.SentToDavinci].Enabled = false;
                    break;

                case Actions.Prices:
                    wdmPricesActions.Items[(int)Actions.Selection].Enabled = true;
                     wdmPricesActions.Items[(int)Actions.Prices].Enabled = false;
                     wdmPricesActions.Items[(int)Actions.SetOverrules].Enabled = true;
                     wdmPricesActions.Items[(int)Actions.SentToDavinci].Enabled = true;
                     break;

                case Actions.SetOverrules:
                case Actions.SentToDavinci:
                default:
                     break;
            }
            
        }
    }
}


  